/*!
 * Copyright (c) 2012 - 2022, Anaconda, Inc., and Bokeh Contributors
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 * 
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * 
 * Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation
 * and/or other materials provided with the distribution.
 * 
 * Neither the name of Anaconda nor the names of any contributors
 * may be used to endorse or promote products derived from this software
 * without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */
(function(root, factory) {
  factory(root["Bokeh"], undefined);
})(this, function(Bokeh, version) {
  let define;
  return (function(modules, entry, aliases, externals) {
    const bokeh = typeof Bokeh !== "undefined" && (version != null ? Bokeh[version] : Bokeh);
    if (bokeh != null) {
      return bokeh.register_plugin(modules, entry, aliases);
    } else {
      throw new Error("Cannot find Bokeh " + version + ". You have to load it prior to loading plugins.");
    }
  })
({
"82ab290c02": function _(e,s,t,i,n){i();const o=(0,e("tslib").__importStar)(e("86de82b1ae"));t.PanelChemistryExtensions=o;(0,e("@bokehjs/base").register_models)(o)},
"86de82b1ae": function _(e,i,d,r,E){r(),E("JSMEEditor",e("62a5ef401e").JSMEEditor),E("NGLViewer",e("19eceeedfd").NGLViewer)},
"62a5ef401e": function _(e,s,t,o,i){o();const l=e("@bokehjs/models/layouts/html_box"),n=e("@bokehjs/core/dom");const r="Not Subscribed";function h(e){var s=e.getMultiSDFstack(),t="No multirecords SDF was pasted into the editor ";return s.length>0&&(t=s.join("$$$$\n")+"$$$$\n"),t}function c(e,s){console.log("setValue - start",e.value);var t=e.value;"smiles"===e.format?(console.log("getting smiles"),t=s.smiles(),console.log("got smiles")):t="mol"===e.format?s.molFile(!1):"mol3000"===e.format?s.molFile(!0):"sdf"===e.format?h(s):s.jmeFile(),e.value!==t&&null!==t&&(console.log("setting value",t),e.value=t),console.log("setValue - end",e.value)}function m(e,s){console.log("setValues - start"),c(e,s),function(e,s){console.log("setOtherValues - start"),e.subscriptions.includes("jme")&&(e.jme=u(s.jmeFile()));e.subscriptions.includes("smiles")&&(e.smiles=u(s.smiles()));e.subscriptions.includes("mol")&&(e.mol=u(s.molFile(!1)));e.subscriptions.includes("mol3000")&&(e.mol3000=u(s.molFile(!0)));e.subscriptions.includes("sdf")&&(e.sdf=u(h(s)));console.log("setOtherValues - end")}(e,s),console.log("setValues - end")}function d(e,s){e.subscriptions.includes("jme")||(e.jme=r),e.subscriptions.includes("smiles")||(e.smiles=r),e.subscriptions.includes("mol")||(e.mol=r),e.subscriptions.includes("mol3000")||(e.mol3000=r),e.subscriptions.includes("sdf")||(e.sdf=r),m(e,s)}function u(e){return null===e?"null":e}class a extends l.HTMLBoxView{constructor(){super(...arguments),this.JSME=window.JSApplet.JSME,this.valueChanging=!0}connect_signals(){super.connect_signals(),this.connect(this.model.properties.value.change,(()=>{console.log("value change",this.model.value),this.valueChanging||(""===this.model.value?this.jsmeElement.reset():this.jsmeElement.readGenericMolecularInput(this.model.value))})),this.connect(this.model.properties.format.change,(()=>{console.log("format change",this.model.format),c(this.model,this.jsmeElement)})),this.connect(this.model.properties.subscriptions.change,(()=>{console.log("subscriptions change",this.model.subscriptions),d(this.model,this.jsmeElement)})),this.connect(this.model.properties.options.change,(()=>{console.log("options change",this.model.options),this.setJSMEOptions()})),this.connect(this.model.properties.guicolor.change,(()=>{console.log("options change",this.model.options),this.setGUIColor()}))}render(){console.log("render - start"),super.render();const e="jsme-"+"xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g,(function(e){var s=16*Math.random()|0;return("x"==e?s:3&s|8).toString(16)})),s=(0,n.div)({class:"jsme-editor",id:e});this.el.appendChild(s),this.jsmeElement=new this.JSME(e,this.getHeight(),this.getWidth(),{options:this.model.options.join(","),guicolor:this.model.guicolor}),this.jsmeElement.readGenericMolecularInput(this.model.value),d(this.model,this.jsmeElement),m(this.model,this.jsmeElement);const t=this;this.jsmeElement.setAfterStructureModifiedCallback((function(e){console.log("event",e),t.valueChanging=!0,m(t.model,t.jsmeElement),t.valueChanging=!1})),console.log("render - end")}setGUIColor(){console.log("setGUIColor",this.model.guicolor),this.jsmeElement.setUserInterfaceBackgroundColor(this.model.guicolor)}setJSMEOptions(){const e=this.model.options.join(",");console.log("setJSMEOptions",e),this.jsmeElement.options(e)}getHeight(){return"stretch_height"!==this.model.sizing_mode&&"stretch_both"!==this.model.sizing_mode||!this.el.style.height?this.model.height?this.model.height.toString()+"px":"100px":this.el.style.height}getWidth(){return"stretch_width"!==this.model.sizing_mode&&"stretch_both"!==this.model.sizing_mode||!this.el.style.width?this.model.width?this.model.width.toString()+"px":"100px":this.el.style.width}resizeJSMEElement(){this.jsmeElement.setSize(this.getWidth(),this.getHeight())}after_layout(){super.after_layout(),this.resizeJSMEElement()}}t.JSMEEditorView=a,a.__name__="JSMEEditorView";class g extends l.HTMLBox{constructor(e){super(e)}static init_JSMEEditor(){this.prototype.default_view=a,this.define((({String:e,Array:s})=>({value:[e,""],format:[e,""],options:[s(e),[]],jme:[e,""],smiles:[e,""],mol:[e,""],mol3000:[e,""],sdf:[e,""],subscriptions:[s(e),[]],guicolor:[e,"#c0c0c0"]})))}}t.JSMEEditor=g,g.__name__="JSMEEditor",g.__module__="panel_chemistry.bokeh_extensions.jsme_editor",g.init_JSMEEditor()},
"19eceeedfd": function _(e,t,s,o,i){o();const n=e("@bokehjs/models/layouts/html_box");class r extends n.HTMLBoxView{connect_signals(){super.connect_signals(),this.connect(this.model.properties.object.change,this.updateStage),this.connect(this.model.properties.extension.change,this.updateStage),this.connect(this.model.properties.representation.change,this.updateStage),this.connect(this.model.properties.color_scheme.change,this.updateParameters),this.connect(this.model.properties.custom_color_scheme.change,this.updateParameters),this.connect(this.model.properties.effect.change,this.updateEffect),this.connect(this.model.properties.background.change,this.setBackgroundcolor)}render(){super.render(),this.el.id="viewport";const e=window.NGL;this._stage=new e.Stage(this.el),this.setBackgroundcolor();const t=this._stage;this.updateStage(),window.addEventListener("resize",(function(){t.handleResize()}),!1)}setBackgroundcolor(){console.log(this.model.background),this._stage.setParameters({backgroundColor:this.model.background})}after_layout(){super.after_layout(),this._stage.handleResize()}updateEffect(){"spin"===this.model.effect?this._stage.setSpin(!0):"rock"===this.model.effect?this._stage.setRock(!0):(this._stage.setSpin(!1),this._stage.setRock(!1))}getParameters(){if("custom"===this.model.color_scheme){var e=this.model.custom_color_scheme;return{color:NGL.ColormakerRegistry.addSelectionScheme(e,"new scheme")}}return{colorScheme:this.model.color_scheme}}updateParameters(){const e=this.getParameters();try{this._stage.compList[0].reprList[0].setParameters(e)}catch(e){console.log(e)}}updateStage(){const e=this.model;if(this._stage.removeAllComponents(),""===e.object)return;const t=this.getParameters();function s(s){s.addRepresentation(e.representation,t),s.autoView()}""!==e.extension?this._stage.loadFile(new Blob([e.object],{type:"text/plain"}),{ext:e.extension}).then(s):e.object.includes("://")?this._stage.loadFile(e.object).then(s):this._stage.loadFile("rcsb://"+e.object).then(s),this.updateEffect()}}s.NGLViewerView=r,r.__name__="NGLViewerView";class c extends n.HTMLBox{constructor(e){super(e)}static init_NGLViewer(){this.prototype.default_view=r,this.define((({String:e,Any:t})=>({object:[e,""],extension:[e,""],representation:[e,"ribbon"],color_scheme:[e,"chainid"],custom_color_scheme:[t,"chainid"],effect:[e,""]}))),this.override({height:400,width:600})}}s.NGLViewer=c,c.__name__="NGLViewer",c.__module__="panel_chemistry.bokeh_extensions.ngl_viewer",c.init_NGLViewer()},
}, "82ab290c02", {"index":"82ab290c02","bokeh_extensions/index":"86de82b1ae","bokeh_extensions/jsme_editor":"62a5ef401e","bokeh_extensions/ngl_viewer":"19eceeedfd"}, {});});
